'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
Class creates element with two states - label, and TextField in edit mode
**/
var EditLabel = function (_Component) {
    _inherits(EditLabel, _Component);

    function EditLabel(props) {
        _classCallCheck(this, EditLabel);

        var _this = _possibleConstructorReturn(this, (EditLabel.__proto__ || Object.getPrototypeOf(EditLabel)).call(this, props));

        _this.bodyClickEvent = null; //click event on page body
        _this.changeDeffer = null;

        _this.state = {

            edit: false, //edit mode
            value: _this.props.value
        };

        return _this;
    }

    _createClass(EditLabel, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {

            this.setState({ value: props.value });
        }

        //input value change handler

    }, {
        key: 'handleChange',
        value: function handleChange(e) {
            var _this2 = this;

            this.setState({ value: e.target.value });

            //deffer to less saving in network
            if (this.changeDeffer != null) clearTimeout(this.changeDeffer);

            this.changeDeffer = setTimeout(function () {

                if (_this2.props.onChange !== null) _this2.props.onChange(_this2.state.value, _this2.props.id);
            }, 400);
        }
    }, {
        key: 'cancelEditMode',
        value: function cancelEditMode() {

            //we clicked ouside current edited element
            this._removeBodyListener();
            this.setState({ edit: false }); //cancel edit
        }
    }, {
        key: '_bodyClickHandler',
        value: function _bodyClickHandler(e) {

            if (!e.target.dataset || typeof e.target.dataset.id === "undefined" || e.target.dataset.id != this.props.id) {

                this.cancelEditMode();
            }
        }
    }, {
        key: '_removeBodyListener',
        value: function _removeBodyListener() {

            if (this.bodyClickEvent !== null) document.removeEventListener("click", this.bodyClickEvent, false);
        }
    }, {
        key: '_addBodyListener',
        value: function _addBodyListener() {

            this._removeBodyListener();
            this.bodyClickEvent = this._bodyClickHandler.bind(this);
            document.addEventListener("click", this.bodyClickEvent, false);
        }
    }, {
        key: 'handleLabelClick',
        value: function handleLabelClick() {

            this.setState({ edit: true });

            //set binding
            this._addBodyListener();
        }
    }, {
        key: 'handleKeyPress',
        value: function handleKeyPress(e) {

            if (e.charCode === 13) {
                //enter

                if (this.props.onEnterClick !== null) this.props.onEnterClick(this.state.value, this.props.id);

                this.cancelEditMode();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var id = _props.id;
            var className = _props.className;
            var onChange = _props.onChange;
            var onKeyPress = _props.onKeyPress;
            var inputClassName = _props.inputClassName;
            var onEnterClick = _props.onEnterClick;
            var labelClassName = _props.labelClassName;

            var other = _objectWithoutProperties(_props, ['id', 'className', 'onChange', 'onKeyPress', 'inputClassName', 'onEnterClick', 'labelClassName']);

            var element = void 0;
            if (this.state.edit) element = _react2.default.createElement(_TextField2.default, _extends({}, other, { ref: 'input', 'data-id': this.props.id, value: this.state.value, className: this.props.inputClassName, onChange: this.handleChange.bind(this), onKeyPress: this.handleKeyPress.bind(this) }));else element = _react2.default.createElement(
                'label',
                { ref: 'label', className: this.props.labelClassName, onClick: this.handleLabelClick.bind(this) },
                this.state.value
            );

            return element;
        }
    }]);

    return EditLabel;
}(_react.Component);

;

EditLabel.propTypes = {
    id: _react2.default.PropTypes.number.isRequired,
    value: _react2.default.PropTypes.string,
    inputClassName: _react2.default.PropTypes.string,
    labelClassName: _react2.default.PropTypes.string,

    onChange: _react2.default.PropTypes.func,
    onEnterClick: _react2.default.PropTypes.func

};

EditLabel.defaultProps = {
    value: "",
    inputClassName: "editlabel-input",
    labelClassName: "editlabel-label",
    onChange: null,
    onEnterClick: null
};

exports.default = EditLabel;